/**********************************************************************************************
Johannes Philippi, Jan.2007
johannesphilippi[a t]web[d o t]de

Delayroutine fr den AT90CAN128
Wartet "ms" Millisekunden ab. Verwendet 8bit Timer0

62500 berlufe des Timers0 entsprechen 62500*256=16'000'000 Takten, das ist genau eine Sekunde
bei 16MHz Taktung des uC.
Eine Millisekunde ist dann 62,5 Timeroverflows lang. Ich rechne mit 62, das einfacher und durch 
die while-Schleifen, die Subtraktionen kommen sowieso noch einige Takte dazu.

Die Zeitintervale sind nicht 100%ig genau, aber doch sehr gut, da mit Timer realisiert.

Damit das ganze funktioniert, muss der Timer initialisiert sein mit folgenden beiden Zeilen
TCCR0A = 0x00;
TCCR0A |= (1<<CS00);
**********************************************************************************************/

/**/
void delayms(uint16_t ms)
{ 
uint16_t x;

x = ms * 62;
//x=62500; 	// dies Zeile wrde eine Sekunde realisieren.

while (x)
   {
     //loop_until_bit_is_set(TIFR0, TOV0);  
     while(!(TIFR0 & (1<<TOV0)));     // Bei jedem berlauf (255) wird hier ein Flag TOV0 gesetzt
         { } 
    
       TIFR0 |= (1<<TOV0);  //TOV0-Bit wieder 1 setzten. 
    
    x--;
   } 
}


